# -*- coding: utf-8 -*-

import os
import sys
import ConfigParser
from qt import *
from configuredialog import ConfigureDialog


class configure(ConfigureDialog):

    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        ConfigureDialog.__init__(self,parent,name,modal,fl)
        self.config = ConfigParser.ConfigParser()
        print "PWD is: " + os.environ["PWD"]
        self.configFile = "unset"
        if os.environ.has_key("KDEHOME"):
            self.configFile = os.environ["KDEHOME"] + "/share/apps/amarok/scripts/podclean/settings.dat"
        else:
            self.configFile = os.environ["HOME"] + "/.kde/share/apps/amarok/scripts/podclean/settings.dat"

        self.loadSettings()
        

    # public slot
    def changeForm(self):
        self.widgetStack1.raiseWidget(self.listBox.currentItem())



    # public slot
    def deleteAllPodcastFilesNow(self):
        print "configure.deleteAllPodcastFilesNow(): Not implemented yet"

    # public slot
    def getSummary(self):
        print "configure.saveSettings(): Not implemented yet"

    # public slot
    def loadSettings(self):
        print "loading config file " + self.configFile
        if os.path.isfile(self.configFile):
            print "reading config from " + self.configFile
            self.config.read(self.configFile)
            print "read config file"
        else:
            print "no config file found using defaults"
            self.setDefaultSettings()
            self.saveSettings()
        
        self.applySettingsToGui()

    # public slot
    def saveSettings(self):
        print "saving settings in " + self.configFile
        # first page - startup
        self.config.set("on_start", "enabled", self.deleteOnStartCheckbox.isChecked())
        if self.startupRadioAll.isChecked():
            self.config.set("on_start", "filter", "all")
        elif self.startupRadioListened.isChecked():
            self.config.set("on_start", "filter", "listened")
        elif self.startupRadioOlder.isChecked():
            self.config.set("on_start", "filter", "byage")
        else:
            print "Don't know how to set on_start.filter config option"

        self.config.set("on_start", "condition_units", self.startupAgeUnits.currentText())
        self.config.set("on_start", "condition_num", self.startupNumSpin.value())
        self.config.set("on_start", "confirm", self.confirmDeletionStartupCheck.isChecked())
        self.config.set("on_start", "notify", self.notifyDeletionStartupCheck.isChecked())

        # second page - periodic scanning
        self.config.set("scan", "enabled", self.scheduleCheckbox.isChecked())
        self.config.set("scan", "scan_time_units", self.scheduleAgeCombo.currentText())
        self.config.set("scan", "scan_time_num", self.scheduleTimeSpin.value())
        if self.scheduleRadioAll.isChecked():
            self.config.set("scan", "filter", "all")
        elif self.scheduleRadioListened.isChecked():
            self.config.set("scan", "filter", "listened")
        elif self.scheduleRadioOlder.isChecked():
            self.config.set("scan", "filter", "byage")
        else:
            print "Don't know how to set scan.filter config option"

        self.config.set("scan", "condition_units", self.scheduleAgeUnitsCombo.currentText())
        self.config.set("scan", "condition_num", self.scheduleNumSpin.value())
        self.config.set("scan", "confirm", self.confirmDeletionScanCheck.isChecked())
        self.config.set("scan", "notify", self.notifyDeletionScanCheck.isChecked())
        
        # save into file
        cfile = open(self.configFile, "w")
        self.config.write(cfile)
        cfile.close()



    # public slot
    def setDefaultSettings(self):
        print "setting defaults"
        self.config.add_section("on_start")
        self.config.set("on_start", "enabled", False)
        # options for filter are "all", "listened", "byage"
        self.config.set("on_start", "filter", "listened")
        self.config.set("on_start", "condition_units", "hours")
        self.config.set("on_start", "condition_num", 4)
        self.config.set("on_start", "confirm", False)
        self.config.set("on_start", "notify", True)
        
        self.config.add_section("scan")
        self.config.set("scan", "enabled", False)
        self.config.set("scan", "scan_time_units", "hours")
        self.config.set("scan", "scan_time_num", 1)
        # options for filter are "all", "listened", "byage"
        self.config.set("scan", "filter", "listened")
        self.config.set("scan", "condition_units", "hours")
        self.config.set("scan", "condition_num", 4)
        self.config.set("scan", "confirm", False)
        self.config.set("scan", "notify", True)
        

    def applySettingsToGui(self):
        print "applying settings"
        # first page of settings - startup
        self.deleteOnStartCheckbox.setChecked(self.config.getboolean("on_start", "enabled"))
        if self.config.get("on_start", "filter") == "all":
            self.startupRadioAll.setChecked(True)
        elif self.config.get("on_start", "filter") == "listened":
            self.startupRadioListened.setChecked(True)
        elif self.config.get("on_start", "filter") == "byage":
            self.startupRadioOlder.setChecked(True)
        else:
            print "Unknown on_start.filter value: " + self.config.get("on_start", "filter")

        self.startupNumSpin.setValue(self.config.getint("on_start", "condition_num"))
        self.startupAgeUnits.setCurrentText(self.config.get("on_start", "condition_units"))
        self.confirmDeletionStartupCheck.setChecked(self.config.getboolean("on_start", "confirm"))
        self.notifyDeletionStartupCheck.setChecked(self.config.getboolean("on_start", "notify"))

        # second page of settings - periondic scanning
        self.scheduleCheckbox.setChecked(self.config.getboolean("scan", "enabled"))
        self.scheduleTimeSpin.setValue(self.config.getint("scan", "scan_time_num"))
        self.scheduleAgeCombo.setCurrentText(self.config.get("scan", "scan_time_units"))
        
        if self.config.get("scan", "filter") == "all":
            self.scheduleRadioAll.setChecked(True)
        elif self.config.get("scan", "filter") == "listened":
            self.scheduleRadioListened.setChecked(True)
        elif self.config.get("scan", "filter") == "byage":
            self.scheduleRadioOlder.setChecked(True)
        else:  
            print "Unknown scan.filter value: " + self.config.get("scan", "filter")

        self.scheduleNumSpin.setValue(self.config.getint("scan", "condition_num"))
        self.scheduleAgeUnitsCombo.setCurrentText(self.config.get("scan", "condition_units"))

        self.confirmDeletionScanCheck.setChecked(self.config.getboolean("scan", "confirm"))
        self.notifyDeletionScanCheck.setChecked(self.config.getboolean("scan", "notify"))
